module Playwright
  # Selectors can be used to install custom selector engines. See [Working with selectors](./selectors.md) for more
  # information.
  class Selectors < PlaywrightApi

    # An example of registering selector engine that queries elements based on a tag name:
    #
    # ```python sync
    # # FIXME: add snippet
    # ```
    def register(name, contentScript: nil, path: nil, script: nil)
      wrap_impl(@impl.register(unwrap_impl(name), contentScript: unwrap_impl(contentScript), path: unwrap_impl(path), script: unwrap_impl(script)))
    end

    # -- inherited from EventEmitter --
    # @nodoc
    def once(event, callback)
      event_emitter_proxy.once(event, callback)
    end

    # -- inherited from EventEmitter --
    # @nodoc
    def on(event, callback)
      event_emitter_proxy.on(event, callback)
    end

    # -- inherited from EventEmitter --
    # @nodoc
    def off(event, callback)
      event_emitter_proxy.off(event, callback)
    end

    private def event_emitter_proxy
      @event_emitter_proxy ||= EventEmitterProxy.new(self, @impl)
    end
  end
end
